# 
from IRC import *
import os
import random
import ssl
import socket
import sys

LINEEND = '\r\n'
# IRC Config
hostname = "irc.spartalinux.xyz"  # Provide a valid server IP/Hostname
port = 6697
channel = "#botdev"
botnick = "botley"
botnickpass = "a.password"
botpass = "unused"

# Need to pass the IRCBot class a socket the reason it doesn't do this itself is 
# so you can set up TLS or not as you need it
# These provide good defaults. But your milage may vary
oursock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
context = ssl.SSLContext()
context.check_hostname = False
context.verify_mode = ssl.CERT_NONE
oursock = context.wrap_socket(oursock, server_hostname=hostname)
irc = IRCBot(oursock)
irc.connect(hostname, port, channel, botnick, botpass, botnickpass)

def generate_response(person, message):
    print(person, message)
    msg = message.strip(LINEEND)
    irc.send_privmsg(channel, str(type(person)) + ' ' + str(type(message)))
    if 'cool.person' in person and msg.lower() == "hello botley":
        return "Greetings Master"
    elif msg.lower() == "hello":
        return "Greetings Human!"
    else:
        return None

while True:
    try:

        text = irc.get_response()
        print(text[0],text[1],text[2])
        if text[1] == 'PRIVMSG' and text[2][0] == channel:
            r = generate_response(text[0],text[2][1])
            if r is not None:
                irc.send_privmsg(channel,r)
    except KeyboardInterrupt:
        irc.send_quit("Ctrl-C Pressed")
        msg = oursock.recv(4096)
        print(msg)
        sys.exit(0)

    
